﻿using System;
using System.Collections.Generic;

namespace GenericLibrary
{
    class Program
    {
        public static void Main(string[] args)
        {
            //EvilProgrammerWorkingWithList();
            EvenMoreEvilProgrammerWorkingWithIEnumerable();
        }

        private static void EvilProgrammerWorkingWithList()
        {
            CatalogList<int, Student> students = new CatalogList<int, Student>();
            Student st1 = new Student(1, "Anders");
            Student st2 = new Student(23, "John");
            students.Add(st1);
            students.Add(st2);
            ICollection<Student> coll = students.GetAll();

            coll.Add(st1); // The Evil Programmer in action
            // Now students has two duplicate elements
            Console.WriteLine(students);
        }

        private static void EvenMoreEvilProgrammerWorkingWithIEnumerable()
        {
            CatalogList<int, Student> students = new CatalogList<int, Student>();
            Student st1 = new Student(1, "Anders");
            Student st2 = new Student(23, "John");
            students.Add(st1);
            students.Add(st2);

            IEnumerable<Student> coll2 = students.GetAllEnumerable();
            // Evil programmer: I only have an IEnumerable. I cannot modify coll2
            // Evil programmer: I guess coll2 is really some kind of ICollection
            //         if I am right then I might be able to modify the collection, let try it!
            ICollection<Student> coll3 = coll2 as ICollection<Student>; // type cast
            if (coll3 != null)
            {
                // Evil programmer: Type cast worked! I can do my evil work!!
                coll3.Add(st1);
                // students now have duplicate elements (st1)
                Console.WriteLine(students);
            }
        }
    }

    class Student : IIdentifiable<int>
    {
        public int Id { get; private set; }
        public String Name { get; set; }

        public Student(int id, string name)
        {
            Id = id;
            Name = name;
        }

        public override string ToString()
        {
            return Id + ": " + Name;
        }
    }
}
