﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using GenericLibrary;

namespace GenericLibraryTests
{
    class Book : IIdentifiable<int>, IEquatable<Book>
    {
        public String Author { get; set; }
        public String Title { get; set; }

        private readonly int _id;

        public int Id { get { return _id; } }

        public Book(int id, string author, string title)
        {
            _id = id;
            Author = author;
            Title = title;
        }

        public override string ToString()
        {
            return string.Format("{0} {1} {2}", Id, Author, Title);
        }

        public bool Equals(Book other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;
            return _id == other._id;
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != this.GetType()) return false;
            return Equals((Book)obj);
        }

        public override int GetHashCode()
        {
            return _id;
        }
    }
}
